#pragma check_stack(off)
#pragma comment(linker,"/OPT:NOWIN98")

#include <windows.h>

#define mFunc(x) int __stdcall WINAPI x(HWND mWnd,HWND aWnd,char *data,char*,BOOL,BOOL)
#define mProc(x) LRESULT CALLBACK x(HWND hwnd,UINT uMsg,WPARAM wParam,LPARAM lParam)

HWND		mHWnd,tWnd,sWnd;
HANDLE		hMap;
LPSTR		mData;

typedef struct
{
	HWND   mHwnd;
	BOOL   mKeep;
} LOADINFO;

// thx to [k]freak for these 2 commands
void RemoveWinStyles(HWND window,int style,long RemStyles)
{
	LONG Styles = GetWindowLong(window, style);
	Styles &= ~RemStyles;
	SetWindowLong(window, style, Styles);
}

void AddWinStyles(HWND window,int style,long AddStyles)
{
	LONG Styles = GetWindowLong(window, style);
	Styles |= AddStyles;
	SetWindowLong(window, style, Styles);
}

// function to dock dialog or window
mFunc(DockToolbar)
{
	HWND temp;
	RECT rc;

	// convert data to HWND
	temp = (HWND)atoi(data);

	// if HWND exist
	if (IsWindow(temp)) {

		// get mIRC Toolbar HWND
		tWnd = FindWindowEx(mWnd,NULL,"mIRC_Toolbar",NULL);

		// change win style to child
		RemoveWinStyles(temp,GWL_STYLE,WS_POPUP);
		AddWinStyles(temp,GWL_STYLE,WS_CHILDWINDOW);

		// get window pos
		GetWindowRect(temp,&rc);

		// set parent and move it to top-left corner
		SetParent(temp,tWnd);
		MoveWindow(temp,0,0,rc.right-rc.left,rc.bottom-rc.top,1);

		// return OK
		strcpy(data,"S_OK");
		return 3;

	}
	else {

		// if HWND invalid, return an error msg
		strcpy(data,"S_ERR - Invalid window");
		return 3;

	}
}

mFunc(DockSwitchbar)
{
	HWND temp;
	RECT rc;

	// convert data to HWND
	temp = (HWND)atoi(data);

	// if HWND exists
	if (IsWindow(temp)) {

		// get mIRC SwitchBar HWND
		sWnd = FindWindowEx(mWnd,NULL,"mIRC_Switchbar",NULL);

		// change win style to child
		RemoveWinStyles(temp,GWL_STYLE,WS_POPUP);
		AddWinStyles(temp,GWL_STYLE,WS_CHILDWINDOW);

		// get window pos
		GetWindowRect(temp,&rc);

		// set parent and move it to top-left corner
		SetParent(temp,sWnd);
		MoveWindow(temp,0,0,rc.right-rc.left,rc.bottom-rc.top,1);

		// return OK
		strcpy(data,"S_OK");
		return 3;

	}
	else {

		// if HWND invalid, return an error msg
		strcpy(data,"S_ERR - Invalid window");
		return 3;

	}

}

void __stdcall LoadDll(LOADINFO *li)
{

	mHWnd = li->mHwnd;
	li->mKeep = TRUE;

	hMap = CreateFileMapping(INVALID_HANDLE_VALUE,0,PAGE_READWRITE,0,4096,"mIRC");
	mData = (LPSTR)MapViewOfFile(hMap,FILE_MAP_ALL_ACCESS,0,0,0);

}

int WINAPI UnloadDll(int timeout)
{
	if (!timeout)
	{
		return 1;
	}
	return 0;
}

//EOF